require 'draw_primitive.rb'
require 'otk_gl_window.rb'

class MYGLWindowViewTriangle < MyGLWindowBase
  def initialize(width, height, title)
    super
    @triangle_object = []
    @line_object = []
  end

  def clear_object()
    @triangle_object.clear()
    @line_object.clear()
  end

  def add_object( triangle )
    @triangle_object << triangle
  end

  def add_line( line )
    @line_object << line
  end

  def draw
    @triangle_object.each do |obj|
      draw_gl_triangle(obj) if obj.ok?
    end
    @line_object.each do |obj|
      draw_gl_line(obj) if obj.ok?
    end
  end

  def draw_gl_triangle(obj)
    p1 = obj.get_point(0)
    p2 = obj.get_point(1)
    p3 = obj.get_point(2)
    GL.Color3(Color.Blue);
    GL.Begin(BeginMode.Triangles);
    GL.vertex3(p1.x, p1.y, p1.z)
    GL.vertex3(p2.x, p2.y, p2.z)
    GL.vertex3(p3.x, p3.y, p3.z)
    GL.end
    GL.Color3(Color.Cyan);
    GL.Begin(BeginMode.LineLoop);
    GL.vertex3(p1.x, p1.y, p1.z)
    GL.vertex3(p2.x, p2.y, p2.z)
    GL.vertex3(p3.x, p3.y, p3.z)
    GL.end
  end

  def draw_gl_line(obj)
    p1 = obj.get_point(0)
    p2 = obj.get_point(1)
    GL.Color3(Color.Cyan);
    GL.Begin(BeginMode.Lines);
    GL.vertex3(p1.x, p1.y, p1.z)
    GL.vertex3(p2.x, p2.y, p2.z)
    GL.end
  end

end
